//+------------------------------------------------------------------+
//|                                                      QQE new.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Green
#property indicator_color2     Gold
#property indicator_color3     Red
#property indicator_color4     DimGray
#property indicator_color5     Lime
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     2
#property indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame                    = "Current time frame";
extern int    SF                           = 5;
extern int    MomentumLength               = 20;
extern int    Price                        = 8;
extern double WP                           = 3.236;
extern bool   Interpolate                  = true;

extern string _                            = "Alerts Settings";
extern bool   alertsOn                     = true;
extern bool   alertsOnZeroCross            = false;
extern bool   alertsOnMomMaSlopeCross      = true;
extern bool   alertsOnMomentumMaCross      = false;
extern bool   alertsOnCurrent              = false;
extern bool   alertsMessage                = true;
extern bool   alertsSound                  = true;
extern bool   alertsEmail                  = false;

extern bool   arrowsVisible                = true;
extern string arrowsIdentifier             = "qqe pcm Arrows1";
extern double arrowsDisplacement           = 1.0;

extern bool   arrowsOnZeroCross            = false;
extern color  arrowsUpZeroCrossColor       = DeepSkyBlue;
extern color  arrowsDnZeroCrossColor       = Red;
extern int    arrowsUpZeroCrossCode        = 233;
extern int    arrowsDnZeroCrossCode        = 234;
extern int    arrowsUpZeroCrossSize        = 1;
extern int    arrowsDnZeroCrossSize        = 1;

extern bool   arrowsOnMomMaSlopeCross      = true;
extern color  arrowsUpMomMaSlopeColor      = LimeGreen;
extern color  arrowsDnMomMaSlopeColor      = Red;
extern int    arrowsUpMomMaSlopeCode       = 119;
extern int    arrowsDnMomMaSlopeCode       = 119;
extern int    arrowsUpMomMaSlopeSize       = 2;
extern int    arrowsDnMomMaSlopeSize       = 2;

extern bool   arrowsOnMomentumMaCross      = false;
extern color  arrowsUpMomentumMaCrossColor = LimeGreen;
extern color  arrowsDnMomentumMaCrossColor = Red;
extern int    arrowsUpMomentumMaCrossCode  = 119;
extern int    arrowsDnMomentumMaCrossCode  = 119;
extern int    arrowsUpMomentumMaCrossSize  = 2;
extern int    arrowsDnMomentumMaCrossSize  = 2;


//
//
//
//
//

double buffer1[];
double buffer2[];
double Trend[];
double HistoU[];
double HistoM[];
double HistoD[];
double work[][6];

double trends[][3];
#define _tmi1 0
#define _tup1 1
#define _tdn1 2

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(6);
   SetIndexBuffer(0,HistoU); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,HistoM); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1, "QQE trend");
   SetIndexBuffer(2,HistoD); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer1);SetIndexDrawBegin(3,MomentumLength);
   SetIndexBuffer(4,Trend);
   SetIndexBuffer(5,buffer2);
   SetLevelValue(0,0); 
   
      //
      //
      //
      //
      //
      
      MomentumLength    = MathMax(MomentumLength,1);
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"  qqe pcm  "+(MomentumLength)+"");
return(0);
}

//
//
//
//
//

int deinit() {  if (!calculateValue && arrowsVisible) deleteArrows(); return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iEma 0
#define iEmm 1
#define iQqe 2
#define iPcm 3
#define tQqe 4
#define tQqs 5

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { HistoU[0] = limit+1; return(0); }
           

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars); 
     if (ArrayRange(trends,0)!=Bars) {  ArrayResize(trends,Bars); }

     double alpha1 = 2.0/(SF+1.0);
     double alpha2 = 2.0/(MomentumLength*2.0);
      
     for (i=limit, r=Bars-i-1; i>=0; i--,r++)
     {  
   
        buffer2[i] = getPrice(Price,i);
      
        double sumMom = 0;
        double sumWgh = 0;
        for (int k=0; (i+k)<Bars && k<MomentumLength; k++)
        {
           double weight = MathSqrt(k+1);
                 sumMom += (buffer2[i]-buffer2[i+k+1])/weight;
                 sumWgh += weight;
        }
        if (sumWgh != 0)         
              buffer1[i] = sumMom/sumWgh; 
        else  buffer1[i] = 0;
      
      work[r][iPcm] = work[r-1][iPcm] + alpha1* (buffer1[i]                            - work[r-1][iPcm]);
      work[r][iEma] = work[r-1][iEma] + alpha2*(MathAbs(work[r-1][iPcm]-work[r][iPcm]) - work[r-1][iEma]);
      work[r][iEmm] = work[r-1][iEmm] + alpha2*(work[r][iEma] - work[r-1][iEmm]);

      //
      //
      //
      //
      //

         double pcm0 = work[r  ][iPcm];
         double pcm1 = work[r-1][iPcm];
         double dar  = work[r  ][iEmm]*WP;
         double tr   = work[r-1][iQqe];
         double dv   = tr;
   
            if (pcm0 < tr) { tr = pcm0 + dar; if ((pcm1 < dv) && (tr > dv)) tr = dv; }
            if (pcm0 > tr) { tr = pcm0 - dar; if ((pcm1 > dv) && (tr < dv)) tr = dv; }
         
      //
      //
      //
      //
      //
         
         work[r][iQqe] = tr;
         work[r][tQqe] = work[r-1][tQqe];
         work[r][tQqs] = work[r-1][tQqs];
         buffer1[i]    = work[r][iPcm];
         Trend[i]      = tr;
         HistoU[i]     = EMPTY_VALUE;
         HistoM[i]     = EMPTY_VALUE;
         HistoD[i]     = EMPTY_VALUE;
   
         if (buffer1[i] > 0)                                       HistoU[i] = buffer1[i];
         if (buffer1[i] < 0)                                       HistoD[i] = buffer1[i];
         if (HistoU[i] == EMPTY_VALUE && HistoD[i] == EMPTY_VALUE) HistoM[i] = buffer1[i];

      //
      //
      //
      //
      //
               
         if (buffer1[i] > 0)        work[r][tQqe] =  1;
         if (buffer1[i] < 0)        work[r][tQqe] = -1;
         if (buffer1[i] > Trend[i]) work[r][tQqs] =  1;
         if (buffer1[i] < Trend[i]) work[r][tQqs] = -1;
         setTrends(i,r);
         manageArrow(i,r); 
         
     }    
     manageAlerts();   
     return(0);
     }
     
     //
     //
     //
     //
     //
     
     limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     if (ArrayRange(trends,0)!=Bars) { ArrayResize(trends,Bars); }
     for (i=limit, r=Bars-i-1; i>=0; i--,r++)
     { 
    
        int y = iBarShift(NULL,timeFrame,Time[i]);
           buffer1[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,MomentumLength,Price,WP,3,y);
           Trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,MomentumLength,Price,WP,4,y);
           HistoU[i] = EMPTY_VALUE;
           HistoM[i] = EMPTY_VALUE;
           HistoD[i] = EMPTY_VALUE;
           
           setTrends(i,r);
           manageArrow(i,r);

           //
           //
           //
           //
           //
               
           if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

           //
           //
           //
           //
           //

           datetime time = iTime(NULL,timeFrame,y);
              for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
              for(int x = 1; x < n; x++)
              {
                 buffer1[i+x] = buffer1[i] + (buffer1[i+n] - buffer1[i]) * x/n;
                 Trend[i+x]   = Trend[i]   + (Trend[i+n]   - Trend[i])   * x/n;
              
              }
              }
              
              if (ArrayRange(trends,0)!=Bars) { ArrayResize(trends,Bars); }
              for (i=limit, r=Bars-i-1; i>=0; i--,r++)
              { 
              
              if (buffer1[i]  > 0)                                       HistoU[i] = buffer1[i];
              if (buffer1[i]  < 0)                                       HistoD[i] = buffer1[i];
              if (HistoU[i]  == EMPTY_VALUE && HistoD[i] == EMPTY_VALUE) HistoM[i] = buffer1[i];

              setTrends(i,r);
              manageArrow(i,r);
     }
   manageAlerts();
return(0);
} 

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void setTrends(int i, int r)
{
   trends[r][_tmi1] = trends[r-1][_tmi1];
   trends[r][_tup1] = trends[r-1][_tup1];
   trends[r][_tdn1] = trends[r-1][_tdn1];
   
   
      if (buffer1[i] > 0)                                     trends[r][_tmi1] =  1;
      if (buffer1[i] < 0)                                     trends[r][_tmi1] = -1;
      if (buffer1[i] > Trend[i] && buffer1[i] > buffer1[i+1]) trends[r][_tup1] =  1;
      if (buffer1[i] < Trend[i] && buffer1[i] < buffer1[i+1]) trends[r][_tup1] = -1;
      if (buffer1[i] > Trend[i])                              trends[r][_tdn1] =  1;
      if (buffer1[i] < Trend[i])                              trends[r][_tdn1] = -1;
      
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnZeroCross && trends[whichBar][_tmi1] != trends[whichBar-1][_tmi1])
      {
         if (trends[whichBar][_tmi1] ==  1) doAlert(time1,mess1,whichBar,"Cross zero line up");
         if (trends[whichBar][_tmi1] == -1) doAlert(time1,mess1,whichBar,"Cross zero line down");
      }
      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnMomMaSlopeCross && trends[whichBar][_tup1] != trends[whichBar-1][_tup1])
      {
         if (trends[whichBar][_tup1] ==  1) doAlert(time2,mess2,whichBar,"Momentum Ma cross and sloping up");
         if (trends[whichBar][_tup1] == -1) doAlert(time2,mess2,whichBar,"Momentum Ma cross and sloping down");
      }
      
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnMomentumMaCross && trends[whichBar][_tdn1] != trends[whichBar-1][_tdn1])
      {
         if (trends[whichBar][_tdn1] ==  1) doAlert(time3,mess3,whichBar,"Momentum Ma cross up");
         if (trends[whichBar][_tdn1] == -1) doAlert(time3,mess3,whichBar,"Momentum Ma cross down");
      }
      
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," QQE Pcm ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," QQE Pcm "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i, int r)
{
   if (!calculateValue && arrowsVisible)
   {
      deleteArrow(Time[i]);
      
      if (arrowsOnZeroCross && trends[r][_tmi1]!=trends[r-1][_tmi1])
      {
         if (trends[r][_tmi1] == 1) drawArrow(i,arrowsUpZeroCrossColor,arrowsUpZeroCrossCode,arrowsUpZeroCrossSize,false);
         if (trends[r][_tmi1] ==-1) drawArrow(i,arrowsDnZeroCrossColor,arrowsDnZeroCrossCode,arrowsDnZeroCrossSize,true);
      }
      
      if (arrowsOnMomMaSlopeCross && trends[r][_tup1]!=trends[r-1][_tup1])
      {
         if (trends[r][_tup1] == 1) drawArrow(i,arrowsUpMomMaSlopeColor,arrowsUpMomMaSlopeCode,arrowsUpMomMaSlopeSize,false);
         if (trends[r][_tup1] ==-1) drawArrow(i,arrowsDnMomMaSlopeColor,arrowsDnMomMaSlopeCode,arrowsDnMomMaSlopeSize,true);
      }
      
      if (arrowsOnMomentumMaCross && trends[r][_tdn1]!=trends[r-1][_tdn1])
      {
         if (trends[r][_tdn1] == 1) drawArrow(i,arrowsUpMomentumMaCrossColor,arrowsUpMomentumMaCrossCode,arrowsUpMomentumMaCrossSize,false);
         if (trends[r][_tdn1] ==-1) drawArrow(i,arrowsDnMomentumMaCrossColor,arrowsDnMomentumMaCrossCode,arrowsDnMomentumMaCrossSize,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize, bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,   theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize);      
         
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

